// Объект SqueezeBox
function SqueezeBox(host){
	var requests = {};
	var subscribers = {};
   var buffer = "";
   this.host = host;
	var device = IR.CreateDevice(IR.DEVICE_CUSTOM_TCP, "SqueezeBox", host, 9090);
   // Событие: Получен ответ от сервера
   IR.AddListener(IR.EVENT_RECEIVE_TEXT, device, function(response){ 
		//IR.Log("Data received=" + response);
		// Дождемся окончания сообщения
      buffer += response;
      if(buffer.charAt(buffer.length - 1) == '\r'){   
         // Отделим ответы друг от друга
         var responses = buffer.split('\r');
         buffer = "";
         while(response = responses.shift()){
            // Находим нужный callback
            for(request in requests){
               //IR.Log("request=" + request);
               if(response.lastIndexOf(request, 0) == 0){
                  requests[request](response.substring(request.length+1), request);
                  delete requests[request];
               }
            }
            // Ищем подписчиков
            for(request in subscribers){
               if(response.lastIndexOf(request, 0) == 0)
                  subscribers[request](response.substring(request.length+1));
            }
         }
      } 
	}, this);
	// Событие: соединение установлено
	IR.AddListener(IR.EVENT_ONLINE, device, function(){ 
		this.Request("login");
		// Вызываем обработчик
		if("Online" in this) 
         this.Online();
	}, this);
	// Событие: соединение потеряно
	IR.AddListener(IR.EVENT_OFFLINE, device, function(){ 
		// Вызываем обработчик
		if("Offline" in this) 
         this.Offline();
	}, this);
	// Отправка запроса к серверу
	this.Request = function(command, callback){
		// Запоминаем callback
		if(callback){
			if(command.charAt(command.length - 1) == '?')
				requests[command.substring(0, command.length - 2)] = callback;
			else
				requests[command] = callback;
		}
		// Отправляем серверу
		device.Send([command, 0xD]);
	}
	// Подписка на изменения
	this.Subscribe = function(command, callback){
      command += " subscribe%3A0";
      // Запоминаем callback
		subscribers[command] = callback;
		// Отправляем серверу
		device.Send([command, 0xD]);
	}
   // Отмена подписки
	this.Unsubscribe = function(command){
		// Удаляем callback
		delete subscribers[command + " subscribe%3A0"];
		// Отправляем серверу
		device.Send([command + " subscribe%3A-", 0xD]);
	}
   // Установка параметров соединения
	this.SetParameters = function(options){
      options = options.split(':');
      device.SetParameters({Host: options[0], Port: options[1]});
   }	
   // Соединение
	this.Connect = function(){
      device.Connect();
   }
   // Разрыв соединения
	this.Disconnect = function(){
      device.Disconnect();
   }
}